<template>
  <div class="app-container">
    <el-card>
      <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="88px">
        <el-form-item label="项目名称" prop="projectName">
          <el-input
            v-model="queryParams.projectName"
            placeholder="请输入项目名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>
      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button
            type="primary"
            plain
            icon="el-icon-plus"
            size="mini"
            @click="handleAdd"
            v-hasPermi="['app:inspection:add']"
          >新增</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="danger"
            plain
            icon="el-icon-delete"
            size="mini"
            :disabled="multiple"
            @click="handleDeleteAll"
            v-hasPermi="['app:inspection:remove']"
          >删除</el-button>
        </el-col>
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>
    </el-card>
    <br>
    <el-card>
      <el-table border stripe  v-loading="loading"  ref="multipleTable" :data="disposalList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55"  />
        <!--  <el-table-column label="ID"  prop="id" width="80" />  -->
        <el-table-column label="项目名称"  prop="projectName" />
        <el-table-column label="结果选项"  prop="result" >
          <template slot-scope="scope">
            <block v-for="(item, i) in scope.row.resultArr" :key="i">
              <span v-if="i > 0">,</span><span>{{ item.name }}</span>
            </block>
          </template>
        </el-table-column>
<!--        <el-table-column label="默认检验项目"  prop="defaultFlag">-->
<!--          <template slot-scope="scope">-->
<!--            <el-tag v-if="scope.row.defaultFlag">是</el-tag>-->
<!--            <el-tag v-else type="info">否</el-tag>-->
<!--          </template>-->
<!--        </el-table-column>-->
        <!--      <el-table-column label="检验时间"  prop="createTime" />-->
        <el-table-column label="操作" width="180"  class-name="small-padding fixed-width">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleView(scope.row)"
            >查看</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              @click="handleUpdate(scope.row)"
              style="margin-right: 10px"
              v-hasPermi="['app:inspection:edit']"
            >修改</el-button>
            <el-popconfirm
              v-hasPermi="['app:inspection:remove']"
              :title="'是否确认删除所选数据项？'"
              @confirm="handleDelete(scope.row)"
            >
              <el-button
                size="mini"
                type="text"
                slot="reference"
                icon="el-icon-delete"
              >删除</el-button>
            </el-popconfirm>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
    </el-card>

    <!-- 添加或修改死淘处理方式对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="650px" append-to-body>
      <el-form ref="form" label-position="left" :model="form" :rules="rules" :disabled="isView" label-width="150px">
        <el-form-item label="项目名称" prop="projectName">
          <el-input v-model="form.projectName" type="textarea" :autosize="{ minRows: 2 }"    show-word-limit maxlength="50" :placeholder="isView ? '' :'请输入项目名称'" />
        </el-form-item>
<!--        <el-form-item label="检验内容" prop="checkContent">-->
<!--          <el-input type="textarea" :autosize="{ minRows: 2 }"   v-model="form.checkContent" maxlength="50" show-word-limit :placeholder="isView ? '' :'请输入检验内容'" />-->
<!--        </el-form-item>-->
<!--        <el-form-item label="检验方法" prop="checkMethod">-->
<!--          <el-input type="textarea" :autosize="{ minRows: 2 }"   v-model="form.checkMethod" maxlength="50" show-word-limit :placeholder="isView ? '' :'请输入检验方法'" />-->
<!--        </el-form-item>-->
        <el-form-item
          v-for="(item, i) in form.resultArr"
          :key="i"
          :label="'结果选项-' + (i + 1) + (i === 0 ? '(默认)': '')"
          :prop="'resultArr.' + i + '.name'"
          :rules="[
            {
              required: true,
              message: '检查结果不能为空',
              trigger: 'blur',
            },
            {
              min: 1,
              max: 10,
              message: '检查结果输入超出最大长度限制（10位）',
              trigger: 'blur',
            },
          ]"
        >
          <el-input
            v-model="item.name"
            placeholder="请输入检查结果"
            class="result-input"
            show-word-limit
            maxlength="10"
          />
          <el-button
            class="result-add"
            type="primary"
            v-if="i == form.resultArr.length - 1"
            @click="addResult"
          ><i class="el-icon-plus"></i
          ></el-button>
          <el-button
            class="result-del"
            type="danger"
            v-if="i > 0 || form.resultArr.length > 1"
            @click="removeResult(i)"
          ><i class="el-icon-minus"></i
          ></el-button>
        </el-form-item>
        <!--        <el-form-item label="检验时间" prop="createTime">-->
        <!--          <el-date-picker-->
        <!--            v-model="form.createTime"-->
        <!--            type="datetime"-->
        <!--            value-format="yyyy-MM-dd HH:mm:ss"-->
        <!--            placeholder="选择日期时间">-->
        <!--          </el-date-picker>-->
        <!--        </el-form-item>-->
<!--        <el-form-item label="默认检验项目" prop="defaultFlag">-->
<!--          <el-switch-->
<!--            v-model="form.defaultFlag"-->
<!--            active-text="是"-->
<!--            inactive-text="否"-->
<!--          >-->
<!--          </el-switch>-->
<!--        </el-form-item>-->
      </el-form>
      <div slot="footer" class="dialog-footer" v-if="!isView">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import { getInspectionPage, addInspectionPage, editInspectionPage, delInspectionPage, getInspectionDetail } from "@/api/app/inspection";
import { getEnvTestPage, addEnvTestPage, editEnvTestPage, delEnvTestPage, getEnvTestDetail } from "../../../api/app/envTest";
import { formatDate } from "../../../utils";
import { required } from "../../../utils/formRules";

export default {
  name: "Inspection",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 表格数据
      disposalList: [],
      // 弹出层标题
      title: "",
      isView:false,
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        projectName: null,
      },
      // 表单参数
      form: {
        projectName: '',
        checkContent: '',
        checkMethod: '',
        result: '',
        createTime: formatDate(new Date()),
        resultArr: [
          {
            name: "",
          },
        ],
        defaultFlag: 0
      },
      rules: {
        projectName: [required('项目名称不能为空')],
        checkContent: [required('校验内容不能为空')],
      },
    }
  },
  created() {
    this.getList();
  },
  methods: {
    addResult() {
      this.form.resultArr.push({
        name: "",
      });
    },
    removeResult(i) {
      this.form.resultArr.splice(i, 1);
    },
    /** 查询检验项目列表 */
    getList() {
      this.loading = true;
      getEnvTestPage(this.queryParams).then(res => {
        this.disposalList = res.data.records;
        this.disposalList.map((item) => {
          item.resultArr = item.result
            ? JSON.parse(item.result)
            : [
              {
                name: "",
              },
            ];
        });
        this.total = res.data.total;
        this.loading = false;
      }).finally(() => {
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.isView = false;
      this.title = "添加环境样品检验项目";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      let params = {
        id: id
      }
      getEnvTestDetail(params).then(res => {
        this.form = res.data;
        let resultArr = this.form.result
          ? JSON.parse(this.form.result)
          : [
            {
              name: "",
            },
          ];
        this.$set(this.form, "resultArr", resultArr);
        this.open = true;
        this.isView = false;
        this.title = "修改环境样品检验项目";
      })
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.reset();
      const id = row.id;
      let params = {
        id: id
      }
      getEnvTestDetail(params).then(res => {
        this.form = res.data;
        let resultArr = this.form.result
          ? JSON.parse(this.form.result)
          : [
            {
              name: "",
            },
          ];
        this.$set(this.form, "resultArr", resultArr);
        this.open = true;
        this.isView = true;
        this.title = "查看环境样品检验项目";
      })
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        projectName: '',
        checkContent: '',
        checkMethod: '',
        result: 0,
        createTime: formatDate(new Date()),
        resultArr: [
          {
            name: "",
          },
        ],
        defaultFlag: 0
      };
      this.resetForm("form");
    },
    /** 提交按钮 */
    submitForm() {
      this.form.result = this.form.resultArr
        ? JSON.stringify(this.form.resultArr)
        : "[]";
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            // 编辑
            editEnvTestPage(this.form).then(res => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            })
          } else {
            // 新增
            addEnvTestPage(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id;
      let params = {
        ids: ids
      }
      delEnvTestPage(params).then(res => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      })
    },
    /** 删除按钮操作 */
    handleDeleteAll() {
      const ids = this.ids;
      this.$modal.confirm('是否确认删除所选数据项？').then(() => {
        let params = {
          ids: ids.join(',')
        }
        delEnvTestPage(params).then(res => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
          this.$refs.multipleTable.clearSelection();
        })
      })
    }
  }
}
</script>

<style scoped>
.result-input {
  width: 300px;
}
.result-add {
  margin-left: 10px;
}
.result-del {
  margin-left: 10px;
}
</style>
